unit Demo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, DBTables,
  DB, Mask, DBCtrls, RptWrks2, RWLabels, RWCtrls, RWAbort;

type
  TForm1 = class(TForm)
    CustSource: TDataSource;
    Cust: TTable;
    CustCustNo: TFloatField;
    CustCompany: TStringField;
    CustAddr1: TStringField;
    CustAddr2: TStringField;
    CustCity: TStringField;
    CustState: TStringField;
    CustZip: TStringField;
    CustPhone: TStringField;
    OrderSource: TDataSource;
    Orders: TTable;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersPaymentMethod: TStringField;
    OrdersItemsTotal: TCurrencyField;
    OrdersAmountPaid: TCurrencyField;
    PrintDialog1: TPrintDialog;
    Panel2: TPanel;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    v: TPanel;
    ScrollBox1: TScrollBox;
    ReportWorks1: TReportWorks;
    Bevel11: TBevel;
    Bevel2: TBevel;
    Label11: TLabel;
    Label5: TLabel;
    Table1: TTable;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    DataSource1: TDataSource;
    DBImage1: TDBImage;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    ComboBox1: TComboBox;
    RWDBText1: TRWDBText;
    RWDBText2: TRWDBText;
    RWDBText3: TRWDBText;
    RWDBText4: TRWDBText;
    RWDBText5: TRWDBText;
    RWDBText6: TRWDBText;
    RWDBMemo1: TRWDBMemo;
    RWText1: TRWText;
    RWText2: TRWText;
    RWText3: TRWText;
    RWText4: TRWText;
    RWText5: TRWText;
    RWText6: TRWText;
    RWSystem1: TRWSystem;
    RWText7: TRWText;
    RWText8: TRWText;
    RWText9: TRWText;
    RWText10: TRWText;
    RWText11: TRWText;
    RWDBText7: TRWDBText;
    RWDBText8: TRWDBText;
    RWDBText9: TRWDBText;
    RWDBText10: TRWDBText;
    RWDBText11: TRWDBText;
    RWText12: TRWText;
    RWText13: TRWText;
    RWSystem2: TRWSystem;
    RWDBCalculate1: TRWDBCalculate;
    RWLabels1: TRWLabels;
    RWDBLabelText1: TRWDBLabelText;
    RWDBLabelText2: TRWDBLabelText;
    RWLabelText1: TRWLabelText;
    RWLabelImage1: TRWLabelImage;
    RWProgress1: TRWProgress;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure RWLabelText1BeforePrint(Sender: TObject);
  private
    { Private declarations }
    procedure PrintHeader;
    procedure PrintReport;
    procedure PrintReport1;
    procedure PrintReport2;
    procedure PrintReport3;
    procedure PrintReport4;
    procedure PrintReport5;
    procedure PrintReport6;
    procedure PrintReport7;
    procedure UpdatePageStatus;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ABuffer:pchar;

implementation

{$R *.DFM}


procedure TForm1.UpdatePageStatus;
begin
  {Update current report page.}
  Label11.Caption := 'Page ' + IntToStr(ReportWorks1.CurrentPage)
                    + ' of ' + IntToStr(ReportWorks1.PageTotal);
  Label5.Caption := 'Zoom : ' + IntToStr(ReportWorks1.ZoomPercent) + '%';
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  {Set range - don't need all database.}
  Cust.SetRange([1220],[1512]);
  {Print the report to the screen.}
  ComboBox1.ItemIndex := 0;
  PrintReport;
end;


procedure TForm1.PrintReport;
begin
   case ComboBox1.ItemIndex of
      0: PrintReport1;
      1: PrintReport2;
      2: PrintReport3;
      3: PrintReport4;
      4: PrintReport5;
      5: PrintReport6;
      6: PrintReport7;
   end;
end;


procedure TForm1.PrintReport1;
var x,y:integer;
begin
{Get bitmap, if it exists.}
with ReportWorks1 do
  begin
  {Margins change later so make sure they are set
   properly on future calls.}
  LeftMargin := 1;
  RightMargin := 1;
  BottomMargin := 1;
  StartDoc;
  RWProgress1.Progress := 0;
  RWProgress1.Step := 9;
  RWProgress1.Text := 'Printing Bio-Life Detail report...';
  RWProgress1.Show;
  LineWidth := lwFine;
  Table1.First;
  y := 1;
  while y < 4 do
     begin
     DrawDblLine;
     SetFont('Arial',24);
     FontItalic;
     ReportFont.Color := clRed;
     Print('Bio Life');
     ReportFont.Color := clBlack;
     FontRegular;
     SetFont('Arial',12);
     SetTab(1.5,jLeft);
     NextLine;
     NextLine;
     DrawDblLine;
     Print('Detail Report');
     PrintRight(DateToStr(Date));
     NextLine;
     DrawLine;
     RWProgress1.StepIt;
     for x := 0 to 1 do
        begin
        NextLine;
        PositionGraphic(jRight,DBImage1.Picture);
        NextLine;
        RWText1.Print;
        RWDBText1.Print;
        RWText2.Print;
        RWDBText2.Print;
        RWText3.Print;
        RWDBText3.Print;
        RWText4.Print;
        RWDBText4.Print;
        RWText5.Print;
        RWDBText5.Print;
        RWText6.Print;
        RWDBText6.Print;
        NextLine;
        NextLIne;
        RWDBMemo1.Print;
        NextLine;
        if x = 0 then DrawLine;
        Table1.Next;
        if not RWProgress1.StepIt then exit;
        end;
     GoToPageBottom;
     DrawLine;
     BottomMargin := 0.5;
     GoToPageBottom;
     RWSystem1.Print;
     BottomMargin := 1;
     Inc(y);
     if y < 4 then NewPage;
     if not RWProgress1.StepIt then exit;
     end;
     EndDoc;
     BottomMargin := 0.5;
     UpdatePageStatus;
     RWProgress1.Hide;
  end;
end;


procedure TForm1.PrintReport2;
var x:integer;
begin
  with ReportWorks1 do
  begin
  LeftMargin := 1;
  RightMargin := 1;
  RWProgress1.Progress := 0;
  RWProgress1.Step := 5;
  RWProgress1.Text := 'Printing Bio-Life Table report...';
  RWProgress1.Show;
  StartDoc;
  SetFont('Times Roman',24);
  ReportFont.Color := clRed;
  Print('Bio Life');
  NextLine;
  NextLine;
  SetFont('Arial',12);
  ReportFont.Color := clBlack;
  Print('Table Report');
  if not RWProgress1.StepIt then exit;
  NextLine;
  NextLine;
  SetFont('Arial',10);
  DefineTable(5);
  SetTableHeader(1,'Category');
  SetTableHeader(2,'Common Name');
  SetTableHeader(3,'Length (cm)');
  SetTableHeader(4,'Species Name');
  SetTableHeader(5,'Species #');
  SetTableColWidth(1,1.2);
  SetTableColWidth(2,1.5);
  SetTableColWidth(3,0.8);
  SetTableColWidth(4,2);
  SetTableColWidth(5,1);
  SetTableColJustify(3,jCenter);
  SetTableColJustify(5,jRight);
  HeaderStyle := hsThickLine;

  Table1.First;
  StartTable;
  while not Table1.EOF do
     begin
     PrintTableString(1,Table1Category.Value);
     PrintTableString(2,Table1Common_Name.Value);
     PrintTableString(3,Table1LengthCm.AsString);
     PrintTableString(4,Table1SpeciesName.Value);
     PrintTableString(5,Table1SpeciesNo.AsString);
     NextTableRow;
     Table1.Next;
     if not RWProgress1.StepIt then exit;
     end;
  Enddoc;
  RWProgress1.Hide;
  UpdatePageStatus;
  end;
end;

procedure TForm1.PrintReport3;
var x:integer;
begin
  with ReportWorks1 do
  begin
  LeftMargin := 1;
  RightMargin := 1;
  RWProgress1.Progress := 0;
  RWProgress1.Step := 6;
  RWProgress1.Text := 'Printing Bio-Life Simple report...';
  RWProgress1.Show;
  StartDoc;
  LineWidth := lwDouble;
  DrawLine;
  NextLine;
  RWText12.Print;
  RWText13.Print;
  RWSystem2.Print;
  LineWidth := lwNormal;
  DrawLine;
  NextLine;
  RWText7.Print;
  RWText8.Print;
  RWText9.Print;
  RWText10.Print;
  RWText11.Print;
  if not RWProgress1.StepIt then exit;
  Table1.First;
  RWDBCalculate1.ResetToZero;
  while not Table1.EOF do
     begin
     RWDBText7.Print;
     RWDBText8.Print;
     RWDBText9.Print;
     RWDBText10.Print;
     RWDBText11.Print;
     Table1.Next;
     if not RWProgress1.StepIt then exit;
     end;
  NextLine;
  RWDBCalculate1.Print;
  GoToPageBottom;
  DrawLine;
  if not RWProgress1.StepIt then exit;
  EndDoc;
  RWProgress1.Hide;
  UpdatePageStatus;
  end;
end;


procedure TForm1.PrintReport4;
var x:integer;
    tmpstr:string;
begin
  with ReportWorks1 do
  begin
  RWProgress1.Progress := 0;
  RWProgress1.Step := 5;
  RWProgress1.Text := 'Printing MAST Detail report...';
  RWProgress1.Show;
  StartDoc;
  ClearTabs;
  LeftMargin := 0.5;
  RightMargin := 0.5;
  GoToPageTop;
  {Tabs for company info.}
  SetTab(0.4,jLeft);
  SetTab(3.5,jLeft);
  SetTab(5.1,jLeft);
  SetTab(6.0,jLeft);
  SetTab(7.5,jRight);
  {Tabs for order info.}
  SetTab(1,jLeft);
  SetTab(2,jLeft);
  SetTab(4.8,jRight);
  SetTab(6.0,jRight);
  {Make sure we are on the first record.}
  Cust.First;
  PrintHeader;
  if not RWProgress1.StepIt then exit;
  while not Cust.EOF do
     begin
     {Shade two lines.}
     ShadeLine(clBlue);
     NextLine;
     ShadeLine(clBlue);
     PreviousLine;
     {FontColor is a new procedure - undocumented in current version.}
     FontColor(clYellow);
     SetFont('Arial',8);
     Print(CustCustNo.AsString);
     SetFont('Arial',14);
     PrintTab(1,CustCompany.Value);
     SetFont('Arial',10);
     PrintTab(2,CustAddr1.Value);
     PrintTab(3,CustCity.Value);
     PrintTab(4,CustState.Value);
     PrintTab(5,CustPhone.Value + '  ');
     NextLine;
     SetFont('Arial',8);
     FontItalic;
     PrintTab(6,'Order No.');
     PrintTab(7,'Payment Method');
     PrintTab(8,'Total');
     PrintTab(9,'Amount Paid');
     NextLine;
     FontRegular;
     SetFont('Arial',10);
     if not RWProgress1.StepIt then exit;
     if IsPageEnd then
        begin
        NewPage;
        PrintHeader;
        end;
     while not Orders.EOF do
        begin
        FontColor(clBlack);
        PrintTab(6,IntToStr(round(OrdersOrderNo.Value)));
        PrintTab(7,OrdersPaymentMethod.Value);
        Str(OrdersItemsTotal.Value:8:2,tmpstr);
        PrintTab(8,tmpstr);
        Str(OrdersAmountPaid.Value:8:2,tmpstr);
        PrintTab(9,tmpstr);
        NextLine;
        if IsPageEnd then
          begin
          NewPage;
          PrintHeader;
          end;
        Orders.Next;
        if not RWProgress1.StepIt then exit;
        end;
     NextLine;
     Cust.Next;
     end;
  EndDoc;
  RWProgress1.Hide;
  UpdatePageStatus;
  end;
end;


procedure TForm1.PrintReport5;
var x:integer;
begin
  with ReportWorks1 do
  begin
  LeftMargin := 0.5;
  RightMargin := 0.5;
  RWProgress1.Progress := 0;
  RWProgress1.Step := 6;
  RWProgress1.Text := 'Printing MAST Table report...';
  RWProgress1.Show;
  StartDoc;
  LineMeasure := lmTextHeight;
  SetFont('Arial',16);
  FontBold;
  Print('Table Examples');
  FontRegular;
  SetFont('Arial',10);
  NextLine;
  NextLine;
  DefineTable(5);
  HeaderStyle := hsNormal;
  SetTableHeader(1,'Company');
  SetTableHeader(2,'Address 1');
  SetTableHeader(3,'City');
  SetTableHeader(4,'State');
  SetTableHeader(5,'Telephone');
  Cust.First;
  StartTable;
  while not Cust.EOF do
     begin
     PrintTableString(1,CustCompany.Value);
     PrintTableString(2,CustAddr1.AsString);
     PrintTableString(3,CustCity.Value);
     PrintTableString(4,CustState.Value);
     PrintTableString(5,CustPhone.Value);
     NextTableRow;
     Cust.Next;
     if not RWProgress1.StepIt then exit;
     end;
  NextLine;
  NextLine;
  SetTableColWidth(1,2.2);
  SetTableColWidth(2,1.8);
  SetTableColWidth(3,1.2);
  SetTableColWidth(4,1);
  SetTableColWidth(5,1.3);
  SetTableColJustify(4,jCenter);
  SetTableColJustify(5,jRight);
  HeaderStyle := hsThickLine;
  Cust.First;
  StartTable;
  while not Cust.EOF do
     begin
     PrintTableString(1,CustCompany.Value);
     PrintTableString(2,CustAddr1.AsString);
     PrintTableString(3,CustCity.Value);
     PrintTableString(4,CustState.Value);
     PrintTableString(5,CustPhone.Value);
     NextTableRow;
     Cust.Next;
     if not RWProgress1.StepIt then exit;
     end;
  NextLine;
  NextLine;
  DefineTable(3);
  SetTableLeftPos(1.5);
  SetTableColWidth(1,2.2);
  SetTableColWidth(2,1);
  SetTableColWidth(3,1.2);
  SetTableHeader(1,'Company');
  SetTableHeader(2,'Customer No.');
  SetTableHeader(3,'Telephone');
  SetTableColJustify(2,jRight);
  SetTableColJustify(3,jRight);
  HeaderStyle := hsDoubleLine;
  Cust.First;
  StartTable;
  while not Cust.EOF do
     begin
     PrintTableString(1,CustCompany.Value);
     PrintTableString(2,CustCustNo.AsString);
     PrintTableString(3,CustPhone.Value);
     NextTableRow;
     Cust.Next;
     if not RWProgress1.StepIt then exit;
     end;
  LineMeasure := lmLinesPerInch;
  EndDoc;
  end;
RWProgress1.Hide;
UpdatePageStatus;
end;


procedure TForm1.PrintReport6;
var x:integer;
    shade:boolean;
begin
  with ReportWorks1 do
  begin
  LeftMargin := 1;
  RightMargin := 1;
  RWProgress1.Progress := 0;
  RWProgress1.Step := 7;
  RWProgress1.Text := 'Printing MAST Simple report...';
  RWProgress1.Show;
  StartDoc;
  ClearTabs;
  ShadeLine(clAqua);
  DrawLine;
  NextLine;
  ShadeLine(clAqua);
  NextLine;
  ShadeLine(clAqua);
  PreviousLine;
  PreviousLine;
  SetFont('Arial',16);
  PrintCenter('MAST Simple Report');
  NextLine;
  NextLine;
  SetFont('Arial',10);
  PrintRight(DateToStr(Date));
  NextLine;
  DrawLine;
  SetTab(2.2,jLeft);
  SetTab(3.9,jLeft);
  SetTab(5.5,jRight);
  SetTab(6.5,jRight);
  FontBold;
  Print('Company');
  PrintTab(1,'Address');
  PrintTab(2,'City');
  PrintTab(3,'State');
  PrintTab(4,'Telephone');
  FontRegular;
  NextLine;
  if not RWProgress1.StepIt then exit;
  shade := true;
  for x := 1 to 4 do
     begin
     Cust.First;
     while not Cust.EOF do
        begin
        if shade then ShadeLine(clYellow);
        shade := not shade;
        Print(CustCompany.Value);
        PrintTab(1,CustAddr1.AsString);
        PrintTab(2,CustCity.Value);
        PrintTab(3,CustState.Value);
        PrintTab(4,CustPhone.Value);
        Cust.Next;
        NextLine;
        if not RWProgress1.StepIt then exit;
        end;
     if not RWProgress1.StepIt then exit;
     end;
  while not IsPageEnd do
     begin
     if shade then ShadeLine(clYellow);
     shade := not shade;
     NextLine;
     end;
  EndDoc;
  RWProgress1.Hide;
  UpdatePageStatus;
  end;
end;

procedure TForm1.PrintReport7;
begin
  RWProgress1.Progress := 0;
  RWProgress1.Text := 'Printing MAST Labels ...';
  RWProgress1.Show;
  RWLabels1.Execute;
  RWProgress1.Progress := 100;
  RWProgress1.Hide;
  UpdatePageStatus;
end;

procedure TForm1.PrintHeader;
{Header for MAST database report.}
begin
  with ReportWorks1 do
     begin
     FontBold;
     FontColor(clBlue);
     SetFont('Times Roman',42);
     Print('MAST');
     SetFont('Arial',16);
     NextLine;
     PrintRight('Marine Adventure Sales Report');
     NextLine;
     NextLine;
     ShadeLine(clBlue);
     FontColor(clYellow);
     SetFont('Arial',10);
     Print(' ReportWorks for Delphi Sample Report');
     FontItalic;
     PrintRight(DateToStr(Date)+'  ');
     FontColor(clBlack);
     FontRegular;
     NextLine;
     NextLine;
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ReportWorks1.NextPage;
  PrintReport;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ReportWorks1.PreviousPage;
  PrintReport
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReportWorks1.LastPage;
  PrintReport;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReportWorks1.FirstPage;
  PrintReport;
end;


procedure TForm1.BitBtn5Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
{Change destination to the printer, print report and reset destination.}
begin
  If PrintDialog1.Execute then
     begin
     if PrintDialog1.FromPage > 0 then
        ReportWorks1.PrintPageFirst := PrintDialog1.FromPage
     else ReportWorks1.PrintPageFirst := 1;
     if PrintDialog1.ToPage > 0 then
        ReportWorks1.PrintPageLast := PrintDialog1.ToPage
     else ReportWorks1.PrintPageLast := 999;
     ReportWorks1.Destination := dPrinter;
     PrintReport;
     ReportWorks1.Destination := dPreview;
     end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  case ReportWorks1.ZoomPercent of
     40  : ReportWorks1.ZoomPercent := 100;
     60  : ReportWorks1.ZoomPercent := 40;
     75  : ReportWorks1.ZoomPercent := 60;
     100 : ReportWorks1.ZoomPercent := 75;
  end;
  PrintReport;
  Screen.Cursor := crDefault;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   ReportWorks1.FirstPage;
   PrintReport;
end;

procedure TForm1.RWLabelText1BeforePrint(Sender: TObject);
begin
  with Custsource.DataSet do
  RWLabelText1.Caption := FieldByName('City').AsString + ', ' + FieldByName('State').AsString + '   ' + FieldByName('Zip').AsString;
end;

end.
